<script>
import { SlpContainer, SlpRow, SlpColumn, SlpTypography } from "slippers-ui";

import GitLabIcon from "../../assets/gitlab.vue";
import SlpTwitter from "../../assets/fa-twitter.vue";
import SlpFacebook from "../../assets/fa-facebook.vue";
import SlpYoutube from "../../assets/fa-youtube.vue";
import SlpLinkedin from "../../assets/fa-linkedin.vue";

import { getPageAvailableLanguages } from "@/services/language.service";

import LanguageSelector from "@/components/Common/language-selector.vue";
import {LANG_OPTIONS} from "@/common/constants";

export default {
  name: "SlpFooter",
  components: {
    LanguageSelector,
    SlpContainer,
    SlpRow,
    SlpColumn,
    SlpTypography,
    GitLabIcon,
    SlpTwitter,
    SlpFacebook,
    SlpYoutube,
    SlpLinkedin,
  },
  props: {
    contentfulFooterData: {
      type: Object,
      required: true,
    },
    contentfulEntryUrl: {
      type: String,
      required: false,
    },
    baseUrl: {
      type: String,
      required: false,
      default: ''
    },
    availableLanguages:{
      type: Array,
      required: false,
    }
  },
  data() {
    return {
      disclaimerShown: false,
      currentYear: new Date().getFullYear(),
      isHandbook: false,
      maxLinksPerColumnMobile: 10,
      finalAvailableLanguages: [],
      footerData: null,
      isBlog: this.baseUrl.includes('blog')
    };
  },
  mounted() {
    this.isHandbook = window.location.href.includes("/handbook");
  },
  async beforeMount() {
    this.footerData = this.formatCtfFooterData(this.contentfulFooterData);

    if(this.availableLanguages && this.availableLanguages.length){
      this.finalAvailableLanguages = this.availableLanguages.map(locale => LANG_OPTIONS.find(lang => locale === lang.value)).filter(lang => lang);
    }else{
      await this.shouldLocalizeNav();
    }
  },
  methods: {
    emitDisclaimer() {
      this.disclaimerShown = !this.disclaimerShown;
    },
    emitOneTrustEvent() {
      let clickEvent = new Event("oneTrustShowSettings", { bubbles: true });
      document.dispatchEvent(clickEvent);
    },
    emitPageSource() {
      let clickEvent = new Event("viewPageSource", { bubbles: true });
      document.dispatchEvent(clickEvent);
    },
    emitIDE() {
      let clickEvent = new Event("webIDE", { bubbles: true });
      document.dispatchEvent(clickEvent);
    },
    async shouldLocalizeNav() {
      this.finalAvailableLanguages = await getPageAvailableLanguages(
        window.location.origin,
        window.location.pathname
      );
    },
    formatCtfFooterData(ctfData) {
      const columns = ctfData.fields.columns.map((column) => ({
        ...column.fields,
        links: column.fields.links.map((link) => link.fields),
        subMenu: (column.fields.subMenu || []).map((menu) => ({
          ...menu.fields,
          links: menu.fields.links.map((link) => link.fields),
        })),
      }));

      return {
        ...ctfData.fields,
        columns,
      };
    },
  },
};
</script>

<template>
  <footer id="be-footer" class="be-nav-footer">
    <SlpContainer class="footer__container">
      <SlpRow class="footer__navigation">
        <SlpColumn :cols="2" class="logo">
          <GitLabIcon />
          <span>®</span>
        </SlpColumn>
        <SlpColumn :cols="10" class="content" v-if="footerData">
          <div
            v-for="item in footerData.columns"
            :key="item.heading"
            class="column"
            :class="{
              column__nested:
                item.subMenu || item.links.length > maxLinksPerColumnMobile,
            }"
          >
            <div
              :class="{
                divided: item.links.length > maxLinksPerColumnMobile,
              }"
            >
              <SlpTypography
                tag="h3"
                variant="body1-bold"
                class="column__heading"
              >
                {{ item.heading }}
              </SlpTypography>
              <ul
                class="links"
                :class="{
                  links__divided: item.links.length > maxLinksPerColumnMobile,
                }"
              >
                <li
                  v-for="(link, index) in item.links"
                  :key="link.text + index"
                  class="links__item"
                >
                  <button
                    v-if="link.isOneTrustButton"
                    :id="link.id"
                    class="ot-sdk-show-settings"
                    @click="emitOneTrustEvent()"
                    v-bind="link.footerGa"
                  >
                    {{ link.text }}
                  </button>
                  <a
                    v-else
                    :href="link.href"
                    class="link"
                    v-bind="link.footerGa"
                    data-ga-location="footer"
                  >
                    {{ link.text }}
                  </a>
                </li>
              </ul>
            </div>
            <div v-if="item.subMenu" class="column-wrapper">
              <div
                v-for="nestedItem in item.subMenu"
                :key="nestedItem.heading"
                class="column"
              >
                <SlpTypography
                  tag="h3"
                  variant="body1-bold"
                  class="column__heading"
                >
                  {{ nestedItem.heading }}
                </SlpTypography>
                <ul class="links">
                  <li
                    v-for="(link, index) in nestedItem.links"
                    :key="link.text + index"
                    class="links__item"
                  >
                    <button
                      v-if="link.isOneTrustButton"
                      :id="link.id"
                      class="ot-sdk-show-settings"
                      @click="emitOneTrustEvent()"
                      v-bind="link.footerGa"
                    >
                      {{ link.name }}
                    </button>
                    <a
                      v-else
                      :href="link.href"
                      class="link"
                      v-bind="link.footerGa"
                      data-ga-location="footer"
                    >
                      {{ link.text }}
                    </a>
                  </li>
                </ul>
              </div>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
      <div class="footer__cta">
        <div
          class="footer__selectors"
          ref="selectors"
          :class="{
            'footer__selectors--two-children': finalAvailableLanguages.length > 1,
          }"
        >
          <LanguageSelector
            v-if="finalAvailableLanguages.length"
            :available-languages="finalAvailableLanguages"
          />
          <div>
            <ul class="social__links">
              <li class="social__links--item">
                <a
                  href="https://twitter.com/gitlab"
                  data-ga-name="twitter"
                  data-ga-location="footer"
                  aria-label="Twitter"
                >
                  <SlpTwitter class="social__links--icon" />
                </a>
              </li>
              <li class="social__links--item">
                <a
                  href="https://www.facebook.com/gitlab"
                  data-ga-name="facebook"
                  data-ga-location="footer"
                  aria-label="Facebook"
                >
                  <SlpFacebook class="social__links--icon" />
                </a>
              </li>
              <li class="social__links--item">
                <a
                  href="https://www.youtube.com/channel/UCnMGQ8QHMAnVIsI3xJrihhg"
                  data-ga-name="youtube"
                  data-ga-location="footer"
                  aria-label="YouTube"
                >
                  <SlpYoutube class="social__links--icon" />
                </a>
              </li>
              <li class="social__links--item">
                <a
                  href="https://www.linkedin.com/company/gitlab-com"
                  data-ga-name="linkedin"
                  data-ga-location="footer"
                  aria-label="LinkedIn"
                >
                  <SlpLinkedin class="social__links--icon" />
                </a>
              </li>
            </ul>
          </div>
        </div>
        <div class="source" v-if="footerData">
          <SlpTypography tag="p">
            {{ footerData.text }}
          </SlpTypography>
          <p class="be-nav-footer__source-buttons">
            <a
              target="_blank"
              class="be-nav-footer__button"
              :href="isBlog? 'https://gitlab.com/gitlab-com/marketing/digital-experience/gitlab-blog': 'https://gitlab.com/gitlab-com/marketing/digital-experience/buyer-experience'"
              data-ga-name="page source"
              data-ga-location="footer"
            >
              {{ footerData.sourceCtaText }}
            </a>

            <a
              v-if="contentfulEntryUrl"
              target="_blank"
              class="be-nav-footer__button"
              :href="contentfulEntryUrl"
              data-ga-name="web ide"
              data-ga-location="footer"
            >
              {{ footerData.editCtaText }}
            </a>

            <a
              v-if="!isBlog"
              href="https://gitlab.com/gitlab-com/marketing/digital-experience/buyer-experience/-/blob/main/CONTRIBUTING.md"
              data-ga-name="please contribute"
              data-ga-location="footer"
              >{{ footerData.contributeCtaText }}</a
            >

            <span v-if="isHandbook" class="cc-license">
              <a
                rel="license"
                href="http://creativecommons.org/licenses/by-sa/4.0/"
                ><img
                  alt="Creative Commons License"
                  style="border-width: 0"
                  src="https://i.creativecommons.org/l/by-sa/4.0/80x15.png"
              /></a>
            </span>
          </p>
          <p>&copy; {{ currentYear }} GitLab Inc.</p>
        </div>
      </div>
    </SlpContainer>
  </footer>
</template>

<style lang="scss">
.be-nav-footer {
  background-color: $color-surface-700;
  color: $color-text-50;
  padding: 40px $spacing-16;

  *,
  ::before,
  ::after {
    box-sizing: border-box;
  }

  .disclaimer {
    background: $color-surface-100;
    padding: 32px 0;
  }

  .container {
    @media (max-width: $breakpoint-md) {
      padding: 0 !important;
    }
  }

  .footer__navigation {
    display: flex;
    justify-content: space-between;
    align-items: flex-start;
    flex-wrap: wrap;
    flex-direction: column;
  }

  .logo {
    margin: 0 auto 0 0;
    display: flex;

    span {
      margin-left: $spacing-4;
      font-size: $text-body-1;
    }
  }

  .content {
    display: flex;
    margin-top: $spacing-48;
    justify-content: space-between;
    flex-wrap: wrap;
    gap: 30px;
  }

  .column-wrapper {
    @media (min-width: $breakpoint-md + 1px) {
      margin-top: $spacing-24;
    }
  }

  .column {
    max-width: 150px;
    width: 100%;
    flex: 1 0 auto;
    min-width: 2rem;

    &__heading {
      margin-bottom: $spacing-16;
    }

    &__nested {
      @media (max-width: $breakpoint-md) {
        max-width: 100%;
        display: flex;
        align-items: flex-start;
        justify-content: space-between;
        gap: 30px;

        & > * {
          width: 145px;
        }
      }
    }
  }

  .divided {
    @media (max-width: $breakpoint-md) {
      width: 100%;
    }
  }
  .links {
    &__item {
      margin-bottom: $spacing-8;
      &:hover {
        text-decoration: underline;
      }
    }
    &__divided {
      @media (max-width: $breakpoint-md) {
        columns: 120px 2;
        column-gap: calc(100% - 290px);
      }
    }
  }

  .link {
    font-size: $text-body-3;
    line-height: $line-height-body-3;
    color: $color-text-50;
  }

  .social__links--icon {
    width: 24px;
    height: auto;
    color: $color-text-50;
    transition: 0.3s;

    &:hover {
      color: $color-accent-400;
    }
  }

  .footer__cta {
    display: flex;
    flex-direction: column;
    padding-top: $spacing-64;
  }

  .footer__selectors {
    display: flex;
    justify-content: flex-end;
    border-bottom: 1px solid $color-primary-300;
    padding-bottom: $spacing-24;
    margin-bottom: $spacing-32;
    flex-direction: column;
    align-items: baseline;

    @media (min-width: $breakpoint-md) {
      flex-direction: row;
    }

    &--two-children {
      justify-content: space-between;
    }
  }

  &__source-buttons {
    display: flex;
    flex-wrap: wrap;
    gap: 8px 24px;
  }

  &__button {
    color: $color-text-50;
    text-decoration: underline;
    border: none;
    padding: 0;
    cursor: pointer;
    font-weight: $font-weight-bold;
    font-size: $text-body-3;

    &--black {
      color: $color-text-300;
    }
  }
  .source {
    p {
      margin-bottom: $spacing-8;
      font-size: $text-body-3;
    }

    a {
      font-weight: $font-weight-bold;
      color: $color-text-50;
      text-decoration: underline;
    }

    img {
      display: inline-block;
      vertical-align: middle;
      margin-left: 5px;
    }
  }

  .social__links {
    display: flex;
    align-items: center;
    margin-top: $spacing-32;
    width: 100%;
    gap: 15px;
  }

  // OneTrust button in footer
  #ot-sdk-btn.ot-sdk-show-settings,
  #ot-sdk-btn.optanon-show-settings {
    color: $color-text-50 !important;
    border: 0 !important;
    border: none !important;
    padding: 0 !important;
    font-size: 14px !important;
    font-family: "GitLab Sans", sans-serif !important;
    text-align: left !important;
    cursor: pointer;

    &:hover {
      text-decoration: underline;
      background: inherit;
    }
  }
}

@media (min-width: $breakpoint-md) {
  .be-nav-footer {
    .footer__cta {
      padding-top: $spacing-96;
    }
    .column {
      max-width: 160px;
    }
  }
}

@media (min-width: 1220px) {
  .be-nav-footer {
    .footer__navigation {
      flex-direction: row;
    }

    .content {
      margin-top: 0;
    }
  }
}

@media (min-width: 829px) {
  .be-nav-footer {
    .social__links {
      margin-top: 0;
      width: inherit;
    }
  }
}
</style>
